/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(__UTILITY_H)
#define __UTILITY_H

const int MAX_INTEGER = 5000;
const int MIN_INTEGER = -5000;

#define OS_9X   0x0001
#define OS_NT   0x0002
#define OS_95   0x0004
#define OS_98   0x0008
#define OS_ME   0x0010
#define OS_NT4  0x0020
#define OS_2K   0x0040
#define OS_XP   0x0080
#define OS_2KXP 0x0100

struct NameValuePair
{
	const char *name;
	int value;
};

HWND GetLitestepDesktop();

int SplitString(const string &process, string &one, string &two, string &three, string &four, string &five);

bool IsOS(const int &os);

string QueryPixelDepth();
string trim(const string &toTrim);

void ModifyStyle(HWND hWnd, DWORD removeStyle, DWORD addStyle);

bool GetxRCBool(const string &prefix, const string &baseName, bool defaultVal = false);
int GetxRCInt(const string &prefix, const string &baseName, int defaultVal, int minVal = MIN_INTEGER, int maxVal = MAX_INTEGER);

int xParseCoord(const string &aString, int defaultVal, int maxVal);
int GetxRCCoord(const string &prefix, const string &baseName, int defaultVal, int maxVal);

string GetxRCString(const string &prefix, const string &baseName, const string &defaultVal);
string GetxRCLine(const string &prefix, const string &baseName, const string &defaultVal);
int GetxRCNamedValue(const string &prefix, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal);

StringList GetxRCLineList(const string &prefix);

int GetxRCColor(const string &prefix, const string &baseName, int defaultVal);

void PaintDesktopEx(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, int xSrc, int ySrc, BOOL updateCache);
void TileBlt(HDC hdcDest, int xDest, int yDest, int cxDest, int cyDest, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc, DWORD rasterOp);

LPTSTR RegQueryStringValue(HKEY hKey, LPCTSTR pszSubKey, LPCTSTR pszValueName, LPTSTR pszBuffer, int nBufferSize, LPTSTR pszDefaultValue);

string IntToString(int input);

#endif
